;;; prioritaetswarteschlange.scm
;;; Stellt die zur Verwaltung einer Prioritaetswarteschlange
;;; notwendigen Funktionen bereit.
;;; Benoetigt ein Vergleichspraedikat vor?, das hier
;;; beispielhaft mit verschiedenen Varianten realisiert ist.

;;; ===== vor? =====
;;; -> Einfach Zahlen
;(define (vor? zahl-1 zahl-2) (< zahl-1 zahl-2))
;;; -> Strings
;(define (vor? string-1 string-2) (string<? string-1 string-2))
;;; -> Wege in Graphen mit der Aktuellen Laenge am Kopf
;(define (vor? weg-1 weg-2) (< (first weg-1) (first weg-2)))
;;; -> Kanten in Graphen mit derLaenge an dritter Position
;(define (vor? kante-1 kante-2) (< (third kante-1) (third kante-2)))

;;; ===== fuege-einen-ein =====
; fuegt ein Element in die Prio-Schlange ein
; benötigt das Praedikat vor?
(define
  (fuege-einen-ein einer vor? priows)
  (cond
    ((null? priows) (list einer))
    ((vor? einer (first priows))
     (cons einer priows))
    (else
     (cons
      (first priows)
      (fuege-einen-ein einer vor? (rest priows))))
    )
  )
; Tests:
;(fuege-einen-ein 10 vor? '(1 11 21)) ; -> '(1 10 11 21)
;(fuege-einen-ein "hund" vor? '("aal" "katze" "ziege"))
;(fuege-einen-ein '(43 M I) vor? '((34 B I) (40 C I) (65 H I)))
;(fuege-einen-ein '(G E 60) vor? '((B H 30) (A B 69)))

;;; ===== fuege-alle-ein =====
; fuegt alle uebergebenen Elemente in die Prio-Schlange ein
(define
  (fuege-alle-ein alle vor? priows)
  (cond
    ((null? alle) priows)
    (else
     (fuege-alle-ein
      (rest alle)
      vor?
      (fuege-einen-ein (first alle) vor? priows)))
    )
  )
; Test:
;(fuege-alle-ein '(33 0 10) vor? '(1 11 21)) ; -> '(0 1 10 11 21 33)
;(fuege-alle-ein '("hund" "ziege" "aal") vor? '("amsel" "katze" "tiger"))
;(fuege-alle-ein '((60 X B I) (103 A B I)(64 H B I)) vor? '((40 C I) (43 M I) (55 P I) (65 H I)))
;(fuege-alle-ein '((A B 69) (A D 36) (A M 36) (A N 22)) vor? '())